Index: branches/0.0.x/include/Pacpus/PacpusTools/geodesie.h
===================================================================
--- branches/0.0.x/include/Pacpus/PacpusTools/geodesie.h	(revision 308)
+++ branches/0.0.x/include/Pacpus/PacpusTools/geodesie.h	(revision 311)
@@ -19,4 +19,7 @@
 #include <vector>
 
+#include "Pacpus\kernel\PacpusToolsConfig.h"
+
+
 namespace Geodesie {
 
@@ -35,5 +38,5 @@
 /// @todo Documentation
 /// @todo Rewrite!
-struct Matrice
+struct PACPUSTOOLS_API Matrice
 {
     /// Copy ctor
@@ -66,12 +69,12 @@
 };
 
-Matrice TransMat(const Matrice A);
-
-Matrice ProdMat(const Matrice A,const Matrice B);
+Matrice PACPUSTOOLS_API TransMat(const Matrice A);
+
+Matrice PACPUSTOOLS_API ProdMat(const Matrice A,const Matrice B);
 void Write(const Matrice A,std::ostream& out);
 
 ////////////////////////////////////////////////////////////////////////
 /// @todo Documentation
-class Raf98
+class PACPUSTOOLS_API Raf98
 {
 public:
@@ -99,6 +102,6 @@
 
 ////////////////////////////////////////////////////////////////////////
-inline double Deg2Rad(double deg) {return deg*M_PI/180.0;}
-inline double Rad2Deg(double rad) {return rad*180.0/M_PI;}
+inline double PACPUSTOOLS_API Deg2Rad(double deg) {return deg*M_PI/180.0;}
+inline double PACPUSTOOLS_API Rad2Deg(double rad) {return rad*180.0/M_PI;}
 ////////////////////////////////////////////////////////////////////////
 
@@ -123,29 +126,29 @@
 
 ////////////////////////////////////////////////////////////////////////
-void Geographique_2_Lambert93(const Raf98& raf98,double lambda,double phi,double he,Matrice in,double& E,double& N,double& h,Matrice& out);
-void Geographique_2_Lambert93(const Raf98& raf98,double lambda,double phi,double he,double& E,double& N,double& h);
-void Lambert93_2_Geographique(const Raf98& raf98,double E,double N,double h,double& lambda,double& phi,double& he);
-void Lambert93_2_Geographique(const Raf98& raf98,double E,double N,double h,Matrice in,double& lambda,double& phi,double& he,Matrice& out);
+void PACPUSTOOLS_API Geographique_2_Lambert93(const Raf98& raf98,double lambda,double phi,double he,Matrice in,double& E,double& N,double& h,Matrice& out);
+void PACPUSTOOLS_API Geographique_2_Lambert93(const Raf98& raf98,double lambda,double phi,double he,double& E,double& N,double& h);
+void PACPUSTOOLS_API Lambert93_2_Geographique(const Raf98& raf98,double E,double N,double h,double& lambda,double& phi,double& he);
+void PACPUSTOOLS_API Lambert93_2_Geographique(const Raf98& raf98,double E,double N,double h,Matrice in,double& lambda,double& phi,double& he,Matrice& out);
 /// Convert from geographique to ECEF.
 /// @param[in] longitude Longitude in radian.
 /// @param[in] latitude Latitude in radian.
 /// @param[in] he Height in meter.
-void Geographique_2_ECEF(double longitude, double latitude, double he, double& x, double& y, double& z);
+void PACPUSTOOLS_API Geographique_2_ECEF(double longitude, double latitude, double he, double& x, double& y, double& z);
 /// Convert from ECEF two ENU.
 /// @param[in] lon0 Longitude of the origin in radian.
 /// @param[in] lat0 Latitude of the origin in radian.
 /// @param[in] he0 Height of the origin in radian.
-void ECEF_2_ENU(double x,double y,double z,double& e,double& n,double& u,double lon0,double lat0,double he0);
+void PACPUSTOOLS_API ECEF_2_ENU(double x,double y,double z,double& e,double& n,double& u,double lon0,double lat0,double he0);
 ////////////////////////////////////////////////////////////////////////
 
 ///ALGO0001
 /// @todo Rename
-double LatitueIsometrique(double latitude,double e);
+double PACPUSTOOLS_API LatitueIsometrique(double latitude,double e);
 ///ALGO0002
 /// @todo Rename
-double LatitueIsometrique2Lat(double latitude_iso,double e,double epsilon);
+double PACPUSTOOLS_API LatitueIsometrique2Lat(double latitude_iso,double e,double epsilon);
 
 ///ALGO0003
-void Geo2ProjLambert(
+void PACPUSTOOLS_API Geo2ProjLambert(
     double lambda,double phi,
     double n, double c,double e,
@@ -153,5 +156,5 @@
     double& X,double& Y);
 ///ALGO0004
-void Proj2GeoLambert(
+void PACPUSTOOLS_API Proj2GeoLambert(
     double X,double Y,
     double n, double c,double e,
@@ -160,5 +163,5 @@
     double& lambda,double& phi);
 
-double ConvMerApp(double longitude);
+double PACPUSTOOLS_API ConvMerApp(double longitude);
 
 /// Converts Cartesian (x, y) coordinates to polar coordinates (r, theta)