Index: trunk/demos/CircleFollower/uav/resources/armv5te/CircleFollower_minidrones.xml
===================================================================
--- trunk/demos/CircleFollower/uav/resources/armv5te/CircleFollower_minidrones.xml	(revision 314)
+++ trunk/demos/CircleFollower/uav/resources/armv5te/CircleFollower_minidrones.xml	(revision 315)
@@ -10,8 +10,8 @@
     </GroupBox>
     <GroupBox name="motor attribution">
-     <ComboBox value="2" name="front left"/>
-     <ComboBox value="0" name="front rigth"/>
+     <ComboBox value="0" name="front left"/>
+     <ComboBox value="1" name="front rigth"/>
      <ComboBox value="3" name="rear left"/>
-     <ComboBox value="1" name="rear rigth"/>
+     <ComboBox value="2" name="rear rigth"/>
     </GroupBox>
     <GroupBox name="bldc">
@@ -148,5 +148,5 @@
    <DoubleSpinBox value="10.5" name="threshold"/>
   </GroupBox>
- </Tab>
+ <GroupBox name="batmon"><Label name="battery"/><DoubleSpinBox name="threshold" value="3.5"/><SpinBox name="threshold time" value="10"/></GroupBox></Tab>
  <Tab name="vrpn">
   <TabWidget name="vrpn">
@@ -166,5 +166,5 @@
     <GroupBox name="Drone_0_euler">
      <DoubleSpinBox value="0" name="period, 0 for auto:"/>
-    </GroupBox>
+    <DoubleSpinBox name="saturation, -1 to disable:" value="-1"/></GroupBox>
     <GroupBox name="target Passe bas">
      <DoubleSpinBox value="0" name="period, 0 for auto"/>
@@ -180,5 +180,5 @@
      <DoubleSpinBox value="0.1" name="acceleration (absolute)"/>
     </GroupBox>
-   </Tab>
+   <GroupBox name="x4_0 Passe bas"><DoubleSpinBox name="period, 0 for auto" value="0.02"/><DoubleSpinBox name="cutoff frequency" value="1"/></GroupBox><GroupBox name="x4_0_euler"><DoubleSpinBox name="period, 0 for auto:" value="0.02"/><DoubleSpinBox name="saturation, -1 to disable:" value="-1"/></GroupBox></Tab>
    <Tab name="Mesures Drone_0">
     <DataPlot1D name="x" period="100" enabled="0">
@@ -231,5 +231,5 @@
     </DataPlot2D>
    </Tab>
-  </TabWidget>
+  <Tab name="Mesures x4_0"><DataPlot1D name="x" period="100" enabled="0"/><DataPlot1D name="y" period="100" enabled="0"/><DataPlot1D name="z" period="100" enabled="0"/><DataPlot1D name="vx" period="100" enabled="0"/><DataPlot1D name="vy" period="100" enabled="0"/><DataPlot1D name="vz" period="100" enabled="0"/></Tab><Tab name="Mesures (xy) x4_0"><DataPlot2D name="xy" period="100" enabled="0"/></Tab></TabWidget>
  </Tab>
  <Tab name="camv">
@@ -268,22 +268,22 @@
     <GroupBox name="u_roll">
      <DoubleSpinBox value="20" name="sat ref:"/>
-     <DoubleSpinBox value="12" name="kp:"/>
-     <DoubleSpinBox value="1000" name="sat dref:"/>
-     <DoubleSpinBox value="0.2" name="kd:"/>
+     <DoubleSpinBox value="5.00" name="kp:"/>
+     <DoubleSpinBox value="500" name="sat dref:"/>
+     <DoubleSpinBox value="0.030" name="kd:"/>
      <DoubleSpinBox value="0.4" name="sat u:"/>
     </GroupBox>
     <GroupBox name="u_pitch">
      <DoubleSpinBox value="20" name="sat ref:"/>
-     <DoubleSpinBox value="12" name="kp:"/>
-     <DoubleSpinBox value="1000" name="sat dref:"/>
-     <DoubleSpinBox value="0.2" name="kd:"/>
+     <DoubleSpinBox value="5.00" name="kp:"/>
+     <DoubleSpinBox value="500" name="sat dref:"/>
+     <DoubleSpinBox value="0.030" name="kd:"/>
      <DoubleSpinBox value="0.4" name="sat u:"/>
     </GroupBox>
     <GroupBox name="u_yaw">
      <DoubleSpinBox value="0" name="period, 0 for auto"/>
-     <DoubleSpinBox value="0.6" name="kp:"/>
+     <DoubleSpinBox value="0.3" name="kp:"/>
      <DoubleSpinBox value="0.1" name="ki:"/>
      <DoubleSpinBox value="0.2" name="sat i:"/>
-     <DoubleSpinBox value="0.2" name="kd:"/>
+     <DoubleSpinBox value="0.1" name="kd:"/>
      <DoubleSpinBox value="0.5" name="sat:"/>
     </GroupBox>
@@ -291,6 +291,6 @@
      <DoubleSpinBox value="0" name="period, 0 for auto"/>
      <DoubleSpinBox value="0.4" name="kp:"/>
-     <DoubleSpinBox value="0.4" name="ki:"/>
-     <DoubleSpinBox value="0" name="sat i:"/>
+     <DoubleSpinBox value="0.1" name="ki:"/>
+     <DoubleSpinBox value="0.00" name="sat i:"/>
      <DoubleSpinBox value="0.2" name="kd:"/>
      <DoubleSpinBox value="0.4" name="sat:"/>
@@ -300,5 +300,5 @@
      <DoubleSpinBox value="0.4" name="kp:"/>
      <DoubleSpinBox value="0.1" name="ki:"/>
-     <DoubleSpinBox value="0" name="sat i:"/>
+     <DoubleSpinBox value="0.00" name="sat i:"/>
      <DoubleSpinBox value="0.2" name="kd:"/>
      <DoubleSpinBox value="0.4" name="sat:"/>
@@ -306,5 +306,5 @@
     <GroupBox name="u_z">
      <DoubleSpinBox value="0" name="period, 0 for auto"/>
-     <DoubleSpinBox value="0.6" name="kp:"/>
+     <DoubleSpinBox value="0.5" name="kp:"/>
      <DoubleSpinBox value="0.2" name="ki:"/>
      <DoubleSpinBox value="0.4" name="sat i:"/>
@@ -354,4 +354,4 @@
   </TabWidget>
  </Tab>
-<Tab name="predictor"><DataPlot1D name="u_pitch" period="100" enabled="1"/></Tab><Tab name="minidrones-us"><TabWidget name="minidrones-us"><Tab name="Reglages"><GroupBox name="minidrones-us"/><GroupBox name="Passe  bas"><DoubleSpinBox name="period, 0 for auto" value="0"/><DoubleSpinBox name="cutoff frequency" value="1"/></GroupBox><GroupBox name="Vz"><DoubleSpinBox name="period, 0 for auto:" value="0"/></GroupBox><GroupBox name="Passe bas  v"><DoubleSpinBox name="period, 0 for auto" value="0"/><DoubleSpinBox name="cutoff frequency" value="1"/></GroupBox><GroupBox name="Passe bas"><DoubleSpinBox name="period, 0 for auto" value="0"/><DoubleSpinBox name="cutoff frequency" value="1"/></GroupBox><GroupBox name="Passe bas v"><DoubleSpinBox name="period, 0 for auto" value="0"/><DoubleSpinBox name="cutoff frequency" value="1"/></GroupBox></Tab><Tab name="Mesures"><DataPlot1D name="minidrones-us" period="100" enabled="1"/><DataPlot1D name="vz" period="100" enabled="0"/></Tab></TabWidget></Tab><Tab name="minidrones-imu_old"><TabWidget name="minidrones-imu"><Tab name="Reglages"><GroupBox name="minidrones-imu"/><DoubleSpinBox name="ka[0]:" value="0.5"/><DoubleSpinBox name="ka[1]:" value="0.5"/><DoubleSpinBox name="ka[2]:" value="0"/><DoubleSpinBox name="kb[0]:" value="0.01"/><DoubleSpinBox name="kb[1]:" value="0.01"/><DoubleSpinBox name="kb[2]:" value="0.01"/><DoubleSpinBox name="km[0]:" value="0.01"/><DoubleSpinBox name="km[1]:" value="0.01"/><DoubleSpinBox name="km[2]:" value="0.01"/><Vector3DSpinBox name="ref magnetic field (uT)" value_x="20.5324001312256" value_y="0.236699998378754" value_z="43.6682014465332"/></Tab><Tab name="AHRS"><DataPlot1D name="roll" period="100" enabled="0"/><DataPlot1D name="pitch" period="100" enabled="0"/><DataPlot1D name="yaw" period="100" enabled="0"/><DataPlot1D name="w_x" period="100" enabled="0"/><DataPlot1D name="w_y" period="100" enabled="0"/><DataPlot1D name="w_z" period="100" enabled="0"/></Tab><Tab name="Quaternion"><DataPlot1D name="q0" period="100" enabled="0"/><DataPlot1D name="q1" period="100" enabled="0"/><DataPlot1D name="q2" period="100" enabled="0"/><DataPlot1D name="q3" period="100" enabled="0"/></Tab><Tab name="IMU"><DataPlot1D name="acc_x" period="100" enabled="0"/><DataPlot1D name="acc_y" period="100" enabled="0"/><DataPlot1D name="acc_z" period="100" enabled="0"/><DataPlot1D name="gyr_x" period="100" enabled="0"/><DataPlot1D name="gyr_y" period="100" enabled="0"/><DataPlot1D name="gyr_z" period="100" enabled="0"/><DataPlot1D name="mag_x" period="100" enabled="0"/><DataPlot1D name="mag_y" period="100" enabled="0"/><DataPlot1D name="mag_z" period="100" enabled="0"/></Tab></TabWidget></Tab></TabWidget>
-<TabWidget name="App_TabWidget"><Tab name="Drone_0"><PushButton name="save config on target" value="1"/></Tab></TabWidget><PushButton name="save config on target (Drone_0)" value="1"/></root>
+<Tab name="predictor"><DataPlot1D name="u_pitch" period="100" enabled="1"/></Tab><Tab name="minidrones-us"><TabWidget name="minidrones-us"><Tab name="Reglages"><GroupBox name="minidrones-us"/><GroupBox name="Passe  bas"><DoubleSpinBox name="period, 0 for auto" value="0"/><DoubleSpinBox name="cutoff frequency" value="1"/></GroupBox><GroupBox name="Vz"><DoubleSpinBox name="period, 0 for auto:" value="0"/></GroupBox><GroupBox name="Passe bas  v"><DoubleSpinBox name="period, 0 for auto" value="0"/><DoubleSpinBox name="cutoff frequency" value="1"/></GroupBox><GroupBox name="Passe bas"><DoubleSpinBox name="period, 0 for auto" value="0"/><DoubleSpinBox name="cutoff frequency" value="1"/></GroupBox><GroupBox name="Passe bas v"><DoubleSpinBox name="period, 0 for auto" value="0"/><DoubleSpinBox name="cutoff frequency" value="1"/></GroupBox></Tab><Tab name="Mesures"><DataPlot1D name="minidrones-us" period="100" enabled="1"/><DataPlot1D name="vz" period="100" enabled="0"/></Tab></TabWidget></Tab><Tab name="minidrones-imu_old"><TabWidget name="minidrones-imu"><Tab name="Reglages"><GroupBox name="minidrones-imu"/><DoubleSpinBox name="ka[0]:" value="0.5"/><DoubleSpinBox name="ka[1]:" value="0.5"/><DoubleSpinBox name="ka[2]:" value="0"/><DoubleSpinBox name="kb[0]:" value="0.01"/><DoubleSpinBox name="kb[1]:" value="0.01"/><DoubleSpinBox name="kb[2]:" value="0.01"/><DoubleSpinBox name="km[0]:" value="0.01"/><DoubleSpinBox name="km[1]:" value="0.01"/><DoubleSpinBox name="km[2]:" value="0.01"/><Vector3DSpinBox name="ref magnetic field (uT)" value_x="20.5324001312256" value_y="0.236699998378754" value_z="43.6682014465332"/></Tab><Tab name="AHRS"><DataPlot1D name="roll" period="100" enabled="0"/><DataPlot1D name="pitch" period="100" enabled="0"/><DataPlot1D name="yaw" period="100" enabled="0"/><DataPlot1D name="w_x" period="100" enabled="0"/><DataPlot1D name="w_y" period="100" enabled="0"/><DataPlot1D name="w_z" period="100" enabled="0"/></Tab><Tab name="Quaternion"><DataPlot1D name="q0" period="100" enabled="0"/><DataPlot1D name="q1" period="100" enabled="0"/><DataPlot1D name="q2" period="100" enabled="0"/><DataPlot1D name="q3" period="100" enabled="0"/></Tab><Tab name="IMU"><DataPlot1D name="acc_x" period="100" enabled="0"/><DataPlot1D name="acc_y" period="100" enabled="0"/><DataPlot1D name="acc_z" period="100" enabled="0"/><DataPlot1D name="gyr_x" period="100" enabled="0"/><DataPlot1D name="gyr_y" period="100" enabled="0"/><DataPlot1D name="gyr_z" period="100" enabled="0"/><DataPlot1D name="mag_x" period="100" enabled="0"/><DataPlot1D name="mag_y" period="100" enabled="0"/><DataPlot1D name="mag_z" period="100" enabled="0"/></Tab></TabWidget></Tab><Tab name="imu"><TabWidget name="imu"><Tab name="Reglages"><GroupBox name="imu"/><GroupBox name="post rotation"><DoubleSpinBox name="value" value="0"/><ComboBox name="axis" value="0"/></GroupBox><DoubleSpinBox name="ka[0]:" value="0.5"/><DoubleSpinBox name="ka[1]:" value="0.5"/><DoubleSpinBox name="ka[2]:" value="0"/><DoubleSpinBox name="kb[0]:" value="0.01"/><DoubleSpinBox name="kb[1]:" value="0.01"/><DoubleSpinBox name="kb[2]:" value="0.01"/><DoubleSpinBox name="km[0]:" value="0.01"/><DoubleSpinBox name="km[1]:" value="0.01"/><DoubleSpinBox name="km[2]:" value="0.01"/><Vector3DSpinBox name="ref magnetic field (uT)" value_x="20.5324001312256" value_y="0.236699998378754" value_z="43.6682014465332"/></Tab><Tab name="AHRS"><DataPlot1D name="roll" period="100" enabled="0"/><DataPlot1D name="pitch" period="100" enabled="0"/><DataPlot1D name="yaw" period="100" enabled="0"/><DataPlot1D name="w_x" period="100" enabled="0"/><DataPlot1D name="w_y" period="100" enabled="0"/><DataPlot1D name="w_z" period="100" enabled="0"/></Tab><Tab name="Quaternion"><DataPlot1D name="q0" period="100" enabled="0"/><DataPlot1D name="q1" period="100" enabled="0"/><DataPlot1D name="q2" period="100" enabled="0"/><DataPlot1D name="q3" period="100" enabled="0"/></Tab><Tab name="IMU"><DataPlot1D name="acc_x" period="100" enabled="0"/><DataPlot1D name="acc_y" period="100" enabled="0"/><DataPlot1D name="acc_z" period="100" enabled="0"/><DataPlot1D name="gyr_x" period="100" enabled="0"/><DataPlot1D name="gyr_y" period="100" enabled="0"/><DataPlot1D name="gyr_z" period="100" enabled="0"/><DataPlot1D name="mag_x" period="100" enabled="0"/><DataPlot1D name="mag_y" period="100" enabled="0"/><DataPlot1D name="mag_z" period="100" enabled="0"/></Tab></TabWidget></Tab><Tab name="us"><TabWidget name="us"><Tab name="Reglages"><GroupBox name="us"/><GroupBox name="Passe bas"><DoubleSpinBox name="period, 0 for auto" value="0"/><DoubleSpinBox name="cutoff frequency" value="1"/></GroupBox><GroupBox name="Vz"><DoubleSpinBox name="period, 0 for auto:" value="0"/><DoubleSpinBox name="saturation, -1 to disable:" value="-1"/></GroupBox><GroupBox name="Passe bas v"><DoubleSpinBox name="period, 0 for auto" value="0"/><DoubleSpinBox name="cutoff frequency" value="1"/></GroupBox></Tab><Tab name="Mesures"><DataPlot1D name="us" period="100" enabled="0"/><DataPlot1D name="vz" period="100" enabled="0"/></Tab></TabWidget></Tab></TabWidget>
+<TabWidget name="App_TabWidget"><Tab name="Drone_0"><PushButton name="save config on target" value="1"/></Tab></TabWidget><PushButton name="save config on target (Drone_0)" value="1"/><PushButton name="save config on target (x4_0)" value="1"/></root>