Index: trunk/lib/FlairFilter/src/ButterworthLowPass_impl.cpp
===================================================================
--- trunk/lib/FlairFilter/src/ButterworthLowPass_impl.cpp	(revision 302)
+++ trunk/lib/FlairFilter/src/ButterworthLowPass_impl.cpp	(revision 318)
@@ -39,5 +39,5 @@
                              " Hz", 0, 10000, 0.1, 2, 1);
 
-  cvmatrix_descriptor *desc = new cvmatrix_descriptor(nbRow, nbCol);
+  MatrixDescriptor *desc = new MatrixDescriptor(nbRow, nbCol);
   //desc->SetElementName(0, 0, "output");
   output = new Matrix(self, desc, floatType, name);
Index: trunk/lib/FlairFilter/src/ControlLaw.cpp
===================================================================
--- trunk/lib/FlairFilter/src/ControlLaw.cpp	(revision 302)
+++ trunk/lib/FlairFilter/src/ControlLaw.cpp	(revision 318)
@@ -18,5 +18,5 @@
 #include "ControlLaw.h"
 #include <Matrix.h>
-#include <cvmatrix_descriptor.h>
+#include <MatrixDescriptor.h>
 #include <DataPlot1D.h>
 #include <sstream>
@@ -34,5 +34,5 @@
     output = new Matrix(this, nb_out, 1, floatType, name);
   } else {
-    cvmatrix_descriptor *desc = new cvmatrix_descriptor(nb_out, 1);
+    MatrixDescriptor *desc = new MatrixDescriptor(nb_out, 1);
     for (int i = 0; i < nb_out; i++) {
       std::stringstream ss;
Index: trunk/lib/FlairFilter/src/EulerDerivative_impl.cpp
===================================================================
--- trunk/lib/FlairFilter/src/EulerDerivative_impl.cpp	(revision 302)
+++ trunk/lib/FlairFilter/src/EulerDerivative_impl.cpp	(revision 318)
@@ -37,5 +37,5 @@
   if (init_value != NULL) {
     // init output matrix of same size as init
-    cvmatrix_descriptor *desc =new cvmatrix_descriptor(init_value->Rows(), init_value->Cols());
+    MatrixDescriptor *desc =new MatrixDescriptor(init_value->Rows(), init_value->Cols());
 
     for (int i = 0; i < init_value->Rows(); i++) {
@@ -53,5 +53,5 @@
   } else {
     // if NULL, assume dimension 1, and init=0
-    cvmatrix_descriptor *desc = new cvmatrix_descriptor(1, 1);
+    MatrixDescriptor *desc = new MatrixDescriptor(1, 1);
     desc->SetElementName(0, 0, "output");
     output = new Matrix(self, desc, floatType, name);
@@ -60,5 +60,5 @@
   
  
-  cvmatrix_descriptor *desc = new cvmatrix_descriptor(output->Rows(), output->Cols());
+  MatrixDescriptor *desc = new MatrixDescriptor(output->Rows(), output->Cols());
   prev_input = new Matrix(self, desc, output->GetDataType().GetElementDataType(), name);
   prev_output = new Matrix(self, desc, output->GetDataType().GetElementDataType(), name);
Index: trunk/lib/FlairFilter/src/JoyReference_impl.cpp
===================================================================
--- trunk/lib/FlairFilter/src/JoyReference_impl.cpp	(revision 302)
+++ trunk/lib/FlairFilter/src/JoyReference_impl.cpp	(revision 318)
@@ -42,5 +42,5 @@
   input = new Matrix(self, 4, 1, floatType, name);
 
-  cvmatrix_descriptor *desc = new cvmatrix_descriptor(4, 1);
+  MatrixDescriptor *desc = new MatrixDescriptor(4, 1);
   desc->SetElementName(0, 0, "z");
   ;
Index: trunk/lib/FlairFilter/src/LowPassFilter_impl.cpp
===================================================================
--- trunk/lib/FlairFilter/src/LowPassFilter_impl.cpp	(revision 302)
+++ trunk/lib/FlairFilter/src/LowPassFilter_impl.cpp	(revision 318)
@@ -38,5 +38,5 @@
   if (init_value != NULL) {
     // init output matrix of same size as init
-    cvmatrix_descriptor *desc =new cvmatrix_descriptor(init_value->Rows(), init_value->Cols());
+    MatrixDescriptor *desc =new MatrixDescriptor(init_value->Rows(), init_value->Cols());
 
     for (int i = 0; i < init_value->Rows(); i++) {
@@ -54,5 +54,5 @@
   } else {
     // if NULL, assume dimension 1, and init=0
-    cvmatrix_descriptor *desc = new cvmatrix_descriptor(1, 1);
+    MatrixDescriptor *desc = new MatrixDescriptor(1, 1);
     desc->SetElementName(0, 0, "output");
     output = new Matrix(self, desc, floatType, name);
Index: trunk/lib/FlairFilter/src/PidThrust_impl.cpp
===================================================================
--- trunk/lib/FlairFilter/src/PidThrust_impl.cpp	(revision 302)
+++ trunk/lib/FlairFilter/src/PidThrust_impl.cpp	(revision 318)
@@ -38,5 +38,5 @@
   self->input = new Matrix(self, 2, 1, floatType, name);
 
-  cvmatrix_descriptor *desc = new cvmatrix_descriptor(5, 1);
+  MatrixDescriptor *desc = new MatrixDescriptor(5, 1);
   desc->SetElementName(0, 0, "p");
   desc->SetElementName(1, 0, "i");
Index: trunk/lib/FlairFilter/src/Pid_impl.cpp
===================================================================
--- trunk/lib/FlairFilter/src/Pid_impl.cpp	(revision 302)
+++ trunk/lib/FlairFilter/src/Pid_impl.cpp	(revision 318)
@@ -36,5 +36,5 @@
   self->input = new Matrix(self, 2, 1, floatType, name);
 
-  cvmatrix_descriptor *desc = new cvmatrix_descriptor(4, 1);
+  MatrixDescriptor *desc = new MatrixDescriptor(4, 1);
   desc->SetElementName(0, 0, "p");
   desc->SetElementName(1, 0, "i");
Index: trunk/lib/FlairFilter/src/TrajectoryGenerator1D_impl.cpp
===================================================================
--- trunk/lib/FlairFilter/src/TrajectoryGenerator1D_impl.cpp	(revision 302)
+++ trunk/lib/FlairFilter/src/TrajectoryGenerator1D_impl.cpp	(revision 318)
@@ -60,5 +60,5 @@
 
   // init matrix
-  cvmatrix_descriptor *desc = new cvmatrix_descriptor(2, 1);
+  MatrixDescriptor *desc = new MatrixDescriptor(2, 1);
   desc->SetElementName(0, 0, "pos");
   desc->SetElementName(1, 0, "vel");
Index: trunk/lib/FlairFilter/src/TrajectoryGenerator2DCircle_impl.cpp
===================================================================
--- trunk/lib/FlairFilter/src/TrajectoryGenerator2DCircle_impl.cpp	(revision 302)
+++ trunk/lib/FlairFilter/src/TrajectoryGenerator2DCircle_impl.cpp	(revision 318)
@@ -51,5 +51,5 @@
 
   // init matrix
-  cvmatrix_descriptor *desc = new cvmatrix_descriptor(2, 2);
+  MatrixDescriptor *desc = new MatrixDescriptor(2, 2);
   desc->SetElementName(0, 0, "pos.x");
   desc->SetElementName(0, 1, "pos.y");
Index: trunk/lib/FlairFilter/src/X4X8Multiplex_impl.cpp
===================================================================
--- trunk/lib/FlairFilter/src/X4X8Multiplex_impl.cpp	(revision 302)
+++ trunk/lib/FlairFilter/src/X4X8Multiplex_impl.cpp	(revision 318)
@@ -50,5 +50,5 @@
   pas->AddItem("clockwise");
 
-  cvmatrix_descriptor *desc = new cvmatrix_descriptor(nb_mot, 1);
+  MatrixDescriptor *desc = new MatrixDescriptor(nb_mot, 1);
   for (int i = 0; i < nb_mot; i++) {
     desc->SetElementName(i, 0, MotorName(i));
Index: trunk/lib/FlairFilter/src/unexported/NestedSat_impl.h
===================================================================
--- trunk/lib/FlairFilter/src/unexported/NestedSat_impl.h	(revision 302)
+++ trunk/lib/FlairFilter/src/unexported/NestedSat_impl.h	(revision 318)
@@ -18,5 +18,4 @@
 namespace flair {
 namespace core {
-class cvmatrix;
 class io_data;
 }